package com.rjconsultores.ventaboletos.dao.hibernate;

import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.TarifaOficialDAO;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.TarifaOficial;

@Repository("tarifaOficialDAO")
public class TarifaOficialHibernateDAO extends GenericHibernateDAO<TarifaOficial, Integer> implements TarifaOficialDAO {

	@Autowired
	public TarifaOficialHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public void gerarTarifaANTT(Ruta ruta) {
		StringBuilder sb = new StringBuilder("");
		sb.append("INSERT INTO TarifaOficial ( ");
		sb.append("        tarifaOficialId, ");
		sb.append("        precio, ");
		sb.append("        precioredabierto, ");
		sb.append("        tramoId, ");
		sb.append("        marcaId, ");
		sb.append("        claseservicio_id, ");
		sb.append("        PRECIOORIGINAL, ");
		sb.append("        MONEDA_ID, ");
		sb.append("        VIGENCIATARIFA_ID, ");
		sb.append("        STATUSTARIFA, ");
		sb.append("        IMPORTETAXAEMBARQUE, ");
		sb.append("        IMPORTEPEDAGIO, ");
		sb.append("        IMPORTEOUTROS, ");
		sb.append("        IMPORTESEGURO, ");
		sb.append("        ORGAOCONCEDENTE_ID, ");
		sb.append("        RUTA_ID, ");
		sb.append("        ACTIVO, ");
		sb.append("        FECMODIF, ");
		sb.append("        USUARIO_ID, ");
		sb.append("       ORIGEN_ID, ");
		sb.append("       DESTINO_ID ");
		sb.append(" ) ");
		/*
		 * select
		 * 
		 * TARIFA_OFICIAL_SEQ.NEXTVAL, ROUND( coalesce(ct1.coeficiente,0) *
		 * coalesce(tc.kmcoeficiente1,0) + coalesce(ct2.coeficiente,0) *
		 * coalesce(tc.kmcoeficiente2,0) + coalesce(ct3.coeficiente,0) *
		 * coalesce(tc.kmcoeficiente3,0),2), null, t.tramo_id, mc.marca_id,
		 * r.CLASESERVICIO_ID, null, m.moneda_id, null, 'A', null, null, null,
		 * null, oc.orgaoconcedente_id, r.ruta_id, 1, sysdate, 999,
		 * po.parada_id, pd.parada_id
		 * 
		 * from ruta_combinacion rc inner join ruta r on r.ruta_id = rc.ruta_id
		 * inner join orgao_tramo tc on tc.tramo_id = rc.tramo_id inner join
		 * orgao_concedente oc on oc.orgaoconcedente_id = tc.orgaoconcedente_id
		 * and oc.orgaoconcedente_id =r.orgaoconcedente_id inner join
		 * coeficiente_tarifa ct1 on ct1.coeficientetarifa_id =
		 * tc.coeficientetarifa1_id left join coeficiente_tarifa ct2 on
		 * ct2.coeficientetarifa_id = tc.coeficientetarifa2_id left join
		 * coeficiente_tarifa ct3 on ct3.coeficientetarifa_id =
		 * tc.coeficientetarifa3_id inner join tramo t on t.tramo_id =
		 * rc.tramo_id inner join parada po on po.parada_id = t.origen_id inner
		 * join parada pd on pd.parada_id = t.destino_id inner join
		 * MARCA_CLASESERVICIO mc on mc.CLASESERVICIO_ID = r.CLASESERVICIO_ID,
		 * moneda m
		 * 
		 * where rc.activo = 1 and r.activo = 1 and m.moneda_id = 1 and
		 * oc.orgaoconcedente_id = 3 and (t.tramo_id, mc.marca_id,
		 * r.CLASESERVICIO_ID, m.moneda_id, oc.orgaoconcedente_id, r.ruta_id)
		 * not in (select
		 * tao.tramo_id,tao.marca_id,tao.CLASESERVICIO_ID,tao.moneda_id
		 * ,tao.orgaoconcedente_id, tao.ruta_id from tarifa_oficial tao where
		 * tao.activo = 1)
		 */
	}

}
