package com.rjconsultores.ventaboletos.service;

import com.rjconsultores.ventaboletos.entidad.Ruta;

public interface TarifaOficialService {

	/**
	 * Gera as tarifas de acordo o clculo da ANTT.<br/>
	 * 
	 * Se o parametro ruta no for informado, ser gerado tarifas para todas as rutas da ANTT.<br/>
	 * 
	 * Obs.: Essa opero apenas gera tarifas que ainda no esto geradas<br/>
	 * 
	 * @param ruta
	 */
	public void gerarTarifaANTT(Ruta ruta);
	
	
	/**
	 * Atualiza as tarifas de acordo o clculo da ANTT<br/>
	 * 
	 * Se o parametro ruta no for informado, ser atualizado as tarifas para todas as rutas da ANTT.<br/>
	 * 
	 * @param ruta
	 */
	public void atualizarTarifaANTT(Ruta ruta);
	
	
}
